/*
struct TIteration3Dext {
double something; // -0x88 ; used in sphereheightmap.m3f
double dum0; // -0x80 ; unknown
double x; // -0x78
double y; // -0x70
double z; // -0x68
double dum1[8]; //unknown
double DE2T; // -0x20 ; Output: distance estimate to current object
double dum2[17]; //unknown
double accumulatedScale; // +0x70
double dum3; // +0x78; unknown
double OTforCol; // +0x80
double dum4[16]; //unknown
//void * sphericalMap; // +0x108; pointer to function
} MB3D_PACK;
*/
#include <math.h>
#define INLI2 __MINGW_INTRIN_INLINE // unlike the normal inline (compiler may disrespect it) , this ENSURES inlining and we need it
#define S0RRY asm volatile          // shortcut

const int szof1int = 4; // helps to find out offsets
const int szof1dbl = 8; // helps to find out offsets

void __attribute__((fastcall)) __main(void);
INLI2 double __cdecl Hypot(double x,double y) ;
INLI2 double __cdecl length2(double x,double y,double z);
INLI2 double __cdecl length(double x,double y,double z);
INLI2 double __cdecl recip (double _x);
INLI2 double __cdecl max (double _a, double _b);
INLI2 double __cdecl min (double _a, double _b);

INLI2 double __cdecl loadzero (void) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fldz": "=t" (res));
  return res;
}

INLI2 double __cdecl load1 (void) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fld1": "=t" (res));
  return res;
}

INLI2 double __cdecl loadZ (void) 
{
  double res;
  S0RRY ("fldl -104(%%esi)" // esi-0x068
        : "=t" (res) 
		:   // nothing in (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"%esi"    // using esi (clobbered));
        );
  return res;
}

INLI2 double __cdecl loadY (void) 
{
  double res;
  S0RRY ("fldl -112(%%esi)" // esi-0x070
        : "=t" (res) 
		:   // nothing in (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"%esi"    // using esi (clobbered));
        );
  return res;
}

INLI2 double __cdecl loadX (void) 
{
  double res;
  S0RRY ("fldl -120(%%esi)" // esi-0x078
        : "=t" (res) 
		:   // nothing in (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"%esi"    // using esi (clobbered));
        );
  return res;
}

INLI2 double __cdecl loadNthDoubleVar (int _nVar, const int OFFSET) // 0 for the 1st ... use only double vars
// ELSE use offset, idk how I go by attempts normally ;(
{
  const int N = -0x010-(_nVar*szof1dbl)-OFFSET;
  double res;
  S0RRY ("fldl %c1(%%edi)"
        : "=t" (res) 
        :"n"(N)   // in
        :"%edi"    // using edi (clobbered));
        );
  return res;
}

INLI2 int __cdecl loadNthIntVar (int _nVar, const int OFFSET) // 0 for the 1st ... use only int vars
// ELSE use offset, idk how I go by attempts normally ;(
// untested
{
  const int N = - 0x0C-(_nVar*szof1int)-OFFSET;
  int res;
  S0RRY ("movl %c1(%%edi),%%eax\n\t" 
        "movl %%eax,%0\n\t"
        : "=m" (res) 
        :"n"(N)   // in
        :"%edi", "%eax"   // using edi and eax (clobbered));
        );
  return res;
}

INLI2 double __cdecl loadNthDoubleCns (int _nVar, const int OFFSET) // 0 for the 1st ... use only double vars
// ELSE use offset, idk how I go by attempts normally ;(
{
  const int N = +(_nVar*szof1dbl)+ 0x000+OFFSET; // EAX
  double res;
  S0RRY ("fldl %c1(%%edi)"
        : "=t" (res) 
        :"n"(N)   // in
        :"%edi"    // using edi (clobbered));
        );
  return res;
}

INLI2 int __cdecl loadNthIntCns (int _nVar, const int OFFSET) // 0 for the 1st ... use only double vars
// ELSE use offset, idk how I go by attempts normally ;(
// untested
{
  const int N = +(_nVar*szof1int)+ 0x000+OFFSET;
  int res;
  S0RRY ("movl %c1(%%edi),%%eax\n\t" 
        "movl %%eax,%0\n\t"
        : "=m" (res) 
        :"n"(N)   // in
        :"%edi", "%eax"   // using edi and eax (clobbered));
        );
  return res;
}

// WARNING don't do this normally except if you really have changed actual coords,
// AND you scaled them by a value... works even in nonlinear changes like Tglad's sphere inv
// If you changed coords, scaling them you must also change this (at the end of your fmla)
INLI2 void __cdecl multScaleFactorBy (double _ScaleF) 
{
  S0RRY ("fldl %0\n\t"
  		"fmull 112(%%esi)\n\t" // esi+0x070
  		"fstpl 112(%%esi)\n\t" // esi+0x070
        : // no out (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"m"(_ScaleF)   // in
        :"%esi"    // using esi (clobbered));
        );
  return;
}

// WARNING don't do this normally except if you really want to change actual coords
INLI2 void __cdecl saveInZ (double _z) 
{
  S0RRY ("fldl %0\n\t"
  		"fstpl -104(%%esi)" // esi-0x068
        : // no out (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"m"(_z)   // in
        :"%esi"    // using esi (clobbered));
        );
  return;
}

// WARNING don't do this normally except if you really want to change actual coords
INLI2 void __cdecl saveInY (double _y)
{
  S0RRY ("fldl %0\n\t"
  		"fstpl -112(%%esi)" // esi-0x070
        : // no out (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"m"(_y)   // in
        :"%esi"    // using esi (clobbered));
        );
  return;
}

// WARNING don't do this normally except if you really want to change actual coords
INLI2 void __cdecl saveInX (double _x)
{
  S0RRY ("fldl %0\n\t"
  		"fstpl -120(%%esi)" // esi-0x078
        : // no out (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"m"(_x)   // in
        :"%esi"    // using esi (clobbered));
        );
  return;
}

INLI2 void __cdecl saveDE (double _DE)
{
  S0RRY ("fldl %0\n\t"
  		"fstpl -32(%%esi)\n\t" // esi-0x020
        : // no out (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"m"(_DE)   // in
        :"%esi"    // using esi (clobbered));
        );
  return;
}

// WARNING don't do this normally except if you really want to change actual coords
INLI2 void __cdecl saveOTColor (double _clr)
{
  S0RRY ("fldl %0\n\t"
  		"fstpl 128(%%esi)" // esi+0x080
        : // no out (well except the memory located into esi+stuff but we won't say that - it's okayish)
        :"m"(_clr)   // in
        :"%esi"    // using esi (clobbered));
        );
  return;
}

INLI2 double __cdecl Hypot(double x,double y) { return sqrt(x*x+y*y); }

INLI2 double __cdecl length2(double x,double y,double z) { return (x*x+y*y+z*z); }

INLI2 double __cdecl length(double x,double y,double z) { return sqrt(length2(x,y,z)); }

INLI2 double __cdecl recip (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fld1\n\t"
	    "fdivp": "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl sqrt (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fsqrt\n\t": "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl exp (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fldl2e\n\t"
  		"fmulp\n\t"
  		"fld1\n\t"
  		"fld %%st(1)\n\t" 
  		"fprem\n\t"
  		"f2xm1\n\t"
  		"faddp\n\t"
  		"fscale\n\t"
  		"fxch\n\t"
  		"fstp %%st\n\t"
  : "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl log (double _x) // uses constants, assembly required :o)
{
  double res;
  S0RRY ("fldln2\n\t"
  		"fxch\n\t"
  		"fyl2x\n\t"
  : "=t" (res) : "0" (_x));
  return res;
}

INLI2 double __cdecl max (double _a, double _b)
{
  return (_a>_b)?_a:_b;
}

INLI2 double __cdecl max3 (double _a, double _b, double _c)
{
  return max(max(_a,_b),_c);
}

INLI2 double __cdecl min (double _a, double _b)
{
  return (_a<_b)?_a:_b;
}

INLI2 double __cdecl min3 (double _a, double _b, double _c)
{
  return min(min(_a,_b),_c);
}

INLI2 double __cdecl length0(double x,double y,double z) { double zzz=loadzero(); return sqrt(length2(max(x, zzz),max(y, zzz),max(z, zzz))); }

INLI2 double smin(double a,double b,double k) { //from iq adapted :P DO NOT!!! do -log
	double ka = -k*a; double kb = -k*b;
	return log(exp(ka)+exp(kb))/(-k);
} 

// ULTRASLIM since Jessie said Mb3D prepares everything for us already
// We just use those lame macros it should be fine I hope? duh
void __attribute__((fastcall)) __main(void) {
/*
	vec3 p=p0+vec3(0.0,1.24,0.0);
	float r=length(p.yz);
	float d= length(max(vec3(abs(p.x)-0.35,r-1.92,-p.y+1.4),0.0))-0.05;
	d=max(d,p.z-1.0);
 */
  double p0x=-loadY()*loadNthDoubleVar(3,0)+loadNthDoubleVar(1,0),
   			p0y=-loadZ()*loadNthDoubleVar(3,0)+loadNthDoubleVar(2,0),
    		p0z=loadX()*loadNthDoubleVar(3,0)+loadNthDoubleVar(0,0); 
    		
  double d=length(p0x, p0y, p0z);
  if (d<loadNthDoubleCns(12,0)) { // speedup-ish
	  double px=p0x, py=p0y+loadNthDoubleCns(9,0), pz=p0z;
	  double r=Hypot(py,pz);
	  d=length0(fabs(px)-loadNthDoubleCns(6,0),
		  r-loadNthDoubleCns(11,0),
		  -py+loadNthDoubleCns(10,0))-loadNthDoubleCns(1,0);
	  d=max(d,pz-load1());
	  double d2,d3;
	/*
		p=p0+vec3(0.0,-0.22,0.39);
		p.xz=abs(p.xz)-vec2(0.5300,0.9600);p.x=abs(p.x);
		r=length(p.yz);
	 */
	  py=p0y-loadNthDoubleCns(13,0); pz=p0z+loadNthDoubleCns(14,0); 
	  px = fabs(fabs(px)-loadNthDoubleCns(7,0));
	  pz = fabs(pz)-loadNthDoubleCns(8,0);
	  r=Hypot(py,pz);
	//  float smin(float a,float b,float k){return -log(exp(-k*a)+exp(-k*b))/k;}//from iq
	//	d2= length(max(vec3(p.x-0.08,r-0.25,-p.y-0.08),0.0)):
	// d=smin(d,d2-0.04,8.0);
	  d2=length0(px-loadNthDoubleCns(2,0),
		  r-loadNthDoubleCns(5,0),
		  -py-loadNthDoubleCns(2,0));
	  d2-=loadNthDoubleCns(0,0);
	  /*
	  if (d2+loadNthDoubleCns(3,0) < d) 
	  saveOTColor(loadNthDoubleVar(4,0));
	  else saveOTColor(loadNthDoubleVar(5,0));
	  */
	  d3=smin(d,d2,loadNthDoubleCns(12,0));
	  d=d3;
	 //	d=min(d,d2-loadNthDoubleCns(0,0)); // NON SMIN
	//	d=max(d,-max(p.x-0.165,r-0.25));
	  d=max(d,-max(px-loadNthDoubleCns(4,0),r-loadNthDoubleCns(5,0)));
	//  d2=length(vec2(max(p.x-0.13,0.0),r-0.2))-0.02;
	  d2=Hypot(max(px-loadNthDoubleCns(3,0),loadzero()),r-loadNthDoubleCns(13,0));
	  d3=min(d,d2-loadNthDoubleCns(15,0));
	  if (d3!= d) 
	  saveOTColor(loadNthDoubleVar(4,0));
	  else saveOTColor(loadNthDoubleVar(5,0));
	  d=d3;
	  d=loadNthIntVar(5,0);
  }
  saveDE (d/loadNthDoubleVar(3,0));
  
/*
cns; loadNthDoubleCns(n,0);

0 = 0.04
1 = 0.05
2 = 0.08
3 = 0.13
4 = 0.165
5 = 0.25
6 = 0.35
7 = 0.5300
8 = 0.9600
9 = 1.24
10 = 1.4
11 = 1.92
12 = 8.0
13 = 0.22
14 = 0.39
15 = 0.02
float mapCar(in vec3 p0){ 
	vec3 p=p0+vec3(0.0,1.24,0.0);
	float r=length(p.yz);
	float d= length(max(vec3(abs(p.x)-0.35,r-1.92,-p.y+1.4),0.0))-0.05;
	d=max(d,p.z-1.0);
	p=p0+vec3(0.0,-0.22,0.39);
	p.xz=abs(p.xz)-vec2(0.5300,0.9600);p.x=abs(p.x);
	r=length(p.yz);
	d=smin(d,length(max(vec3(p.x-0.08,r-0.25,-p.y-0.08),0.0))-0.04,8.0);
	d=max(d,-max(p.x-0.165,r-0.25));
	float d2=length(vec2(max(p.x-0.13,0.0),r-0.2))-0.02;
	d=min(d,d2);

	return d;
}
*/
}
